%define	enable_tests		0
%define	extraver		%{nil}
%define multilib_64_archs	x86_64
%define perlmodcompat		5.8.6 5.8.5 5.8.4 5.8.3
%define thread_arch		-thread-multi

Summary:	The Perl programming language.
Name:		perl
Group:		Development/Languages
License:	Atristic
Version:	5.8.7
Release:	6
Epoch:		1

Source0:	ftp://ftp.perl.org/pub/perl/CPAN/src/perl-%{version}%{extraver}.tar.bz2
Source1:	clean-manifest.pl
Source9:	MANIFEST.suidperl
Source10:	system-owned-directories
Source11:	perl-5.8.7-filter-depends-gd-1.sh
Source12:	perl-5.8.0-libnet.cfg

Patch1:		perl-5.8.0-root.patch
Patch2:		perl-5.8.5-ExtUtils-FHS-fixes-gd-1.diff
Patch3:		perl-5.8.7-Errno-fixes-gd-1.diff
Patch4:		perl-5.8.5-suid-syslog-alert-gd-1.diff
Patch5:		perl-5.8.0-sharedlinker.patch
Patch6:		perl-5.8.0-rpath-make.patch
Patch7:		perl-5.8.1-RC2-fix-version-requirements-gd-1.diff
Patch8:		perl-5.8.7-libdir64-gd-1.diff
Patch9:		perl-5.8.7-quiet-setlocale-warnings-gd-1.diff
Buildroot:	%{_tmppath}/%{name}-%{version}-root
BuildRequires:	gawk, grep, tcsh, gdbm-devel, db4-devel

Obsoletes:	perl-Digest-MD5
Obsoletes:	perl-MIME-Base64
Obsoletes:	perl-libnet
Obsoletes:	perl-Storable
Obsoletes:	perl-CGI <= 2:2.81-88
Obsoletes:	perl-CPAN <= 2:1.61-88
Obsoletes:	perl-DB_File <= 2:1.804-88

Provides:	perl <= %{version}
Provides:	perl(:MODULE_COMPAT_5.8.3)
Provides:	perl(:MODULE_COMPAT_5.8.4)
Provides:	perl(:MODULE_COMPAT_5.8.5)
Provides:	perl(:MODULE_COMPAT_5.8.6)
Provides:	perl(:MODULE_COMPAT_5.8.7)
Provides:	perl(:WITH_ITHREADS)
Provides:	perl(:WITH_LARGEFILES)
Provides:	perl(:WITH_PERLIO)
Provides:	perl(:WITH_THREADS)
Provides:	perl(VMS::Filespec)
Provides:	perl(VMS::Stdio)
Provides:	perl(Mac::Files)
Provides:	perl(FCGI)
Provides:	perl(abbrev.pl)
Provides:	perl(assert.pl)
Provides:	perl(bigfloat.pl)
Provides:	perl(bigint.pl)
Provides:	perl(bigrat.pl)
Provides:	perl(bytes_heavy.pl)
Provides:	perl(cacheout.pl)
Provides:	perl(complete.pl)
Provides:	perl(ctime.pl)
Provides:	perl(dotsh.pl)
Provides:	perl(dumpvar.pl)
Provides:	perl(exceptions.pl)
Provides:	perl(fastcwd.pl)
Provides:	perl(find.pl)
Provides:	perl(finddepth.pl)
Provides:	perl(flush.pl)
Provides:	perl(ftp.pl)
Provides:	perl(getcwd.pl)
Provides:	perl(getopt.pl)
Provides:	perl(getopts.pl)
Provides:	perl(hostname.pl)
Provides:	perl(importenv.pl)
Provides:	perl(look.pl)
Provides:	perl(newgetopt.pl)
Provides:	perl(open2.pl)
Provides:	perl(open3.pl)
Provides:	perl(perl5db.pl)
Provides:	perl(pwd.pl)
Provides:	perl(shellwords.pl)
Provides:	perl(stat.pl)
Provides:	perl(syslog.pl)
Provides:	perl(tainted.pl)
Provides:	perl(termcap.pl)
Provides:	perl(timelocal.pl)
Provides:	perl(utf8_heavy.pl)
Provides:	perl(validate.pl)

# XXX
%define __perl_requires %{SOURCE11}

%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications are system
administration utilities and web programming.  A large proportion of
the CGI scripts on the web are written in Perl.  You need the perl
package installed on your system so that your system can handle Perl
scripts.

%files -f MANIFEST.all
  %defattr(-,root,root)

%package suidperl
Summary:	suidperl, for use with setuid perl scripts
Group:		Development/Languages
Requires:	perl = %{epoch}:%{version}-%{release}

%files suidperl
  %defattr(-,root,root)
  %attr(4511,root,root)	%{_bindir}/suidperl
  %attr(4511,root,root)	%{_bindir}/sperl%{version}

%description suidperl
suidperl is a setuid binary copy of perl that allows for (hopefully)
more secure running of setuid perl scripts.

%prep
%setup -q -n %{name}-%{version}%{extraver}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%ifarch %{multilib_64_archs}
%patch8 -p1
%endif
%patch9 -p1

  # Kill patch fodder.
  find . -name \*.orig -exec rm -fv {} \;

%build
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

sh Configure -des -Doptimize="$RPM_OPT_FLAGS" \
	-Dversion=%{version} \
	-Dmyhostname=localhost \
	-Dperladmin=root@localhost \
	-Dcc='%{__cc}' \
	-Dcf_by='Guardian Digital, Inc.' \
	-Dcccdlflags='-fPIC' \
	-Dinstallprefix=$RPM_BUILD_ROOT%{_prefix} \
	-Dprefix=%{_prefix} \
	-Darchname=%{_arch}-%{_os} \
	-Dvendorprefix=%{_prefix} \
	-Dsiteprefix=%{_prefix} \
	-Dotherlibdirs=/%{_libdir}/perl5/%{version} \
	-Duseshrplib \
	-Dusethreads \
	-Duseithreads \
	-Dd_dosuid \
	-Dd_semctl_semun \
	-Di_db \
	-Di_ndbm \
	-Di_gdbm \
	-Di_shadow \
	-Di_syslog \
	-Dman3ext=3pm \
	-Uuselargefiles \
	-Duseperlio \
	-Dinstallusrbinperl \
	-Ubincompat5005 \
	-Uversiononly \
	-Dpager='/usr/bin/less -isr' \
	-Dd_gethostent_r_proto \
	-Ud_endhostent_r_proto \
	-Ud_endprotoent_r_proto \
	-Ud_endservent_r_proto \
	-Ud_sethostent_r_proto \
	-Ud_setprotoent_r_proto \
	-Ud_setservent_r_proto \
%ifarch %{multilib_64_archs}
	-Dlibpth="/usr/local/lib64 /lib64 /usr/lib64" \
	-Dprivlib="/usr/lib/perl5/%{version}" \
	-Dsitelib="/usr/lib/perl5/site_perl/%{version}" \
	-Dvendorlib="/usr/lib/perl5/vendor_perl/%{version}" \
	-Darchlib="%{_libdir}/perl5/%{version}/%{_arch}-%{_os}%{thread_arch}" \
	-Dsitearch="%{_libdir}/perl5/site_perl/%{version}/%{_arch}-%{_os}%{thread_arch}" \
	-Dvendorarch="%{_libdir}/perl5/vendor_perl/%{version}/%{_arch}-%{_os}%{thread_arch}" \
%endif
	-Dinc_version_list='%{perlmodcompat}'

  make

%if %{enable_tests}
  make test || /bin/true
%endif

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  mkdir -p $RPM_BUILD_ROOT

  make install -f Makefile

  # XXX
  pushd $RPM_BUILD_ROOT/%{_libdir}/perl5
  for i in %{perlmodcompat}; do
	mkdir -pm 755 $i/%{_arch}-%{_os}%{thread_arch}/CORE
	mkdir -pm 755 $i/%{_arch}-%{_os}%{thread_arch}/auto
	pushd $i/%{_arch}-%{_os}%{thread_arch}/CORE
	ln -s ../../../%{version}/%{_arch}-%{_os}%{thread_arch}/CORE/libperl.so libperl.so
	popd
  done
  popd

%ifarch %{multilib_64_archs}
  mkdir -p $RPM_BUILD_ROOT/usr/lib64/perl5/vendor_perl/%{version}/%{_arch}-%{_os}
%endif

  # XXX
  mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
  install -m 755 utils/pl2pm ${RPM_BUILD_ROOT}%{_bindir}/pl2pm

  # XXX
  %define new_perl_lib	$RPM_BUILD_ROOT%{_libdir}/perl5/%{version}:$RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}
  %define comp_perl_lib	$RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}:$RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}
  %define new_arch_lib	$RPM_BUILD_ROOT%{_libdir}/perl5/%{version}/%{_arch}-%{_os}%{thread_arch}
  %define comp_arch_lib	$RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}/%{_arch}-%{_os}%{thread_arch}
  %define new_perl_flags LD_PRELOAD=/%{new_arch_lib}/CORE/libperl.so LD_LIBRARY_PATH=%{new_arch_lib}/CORE PERL5LIB=%{new_perl_lib}:%{comp_perl_lib}
  %define new_perl	%{new_perl_flags} $RPM_BUILD_ROOT/%{_bindir}/perl

  # Make critical .ph files.
  for i in asm/termios.h syscall.h syslimits.h syslog.h sys/ioctl.h sys/socket.h sys/time.h wait.h
  do
    %{new_perl} $RPM_BUILD_ROOT/%{_bindir}/h2ph -a \
		-d $RPM_BUILD_ROOT%{_libdir}/perl5/%{version}/%{_arch}-%{_os}%{thread_arch} $i || /bin/true
  done

  # XXX
  # XXX
  # XXX
  %{new_perl} -p -i -e "s|$RPM_BUILD_ROOT||g;" %{new_arch_lib}/Config.pm

  # XXX
  for dir in $(%{new_perl} -le 'print join("\n", @INC)' | grep '^/usr/lib')
  do
    mkdir -p $RPM_BUILD_ROOT/$dir
  done

  for dir in $(%{new_perl} -le 'print join("\n", @INC)' | grep '^%{_libdir}')
  do
    mkdir -p $RPM_BUILD_ROOT/$dir
  done

  # XXX
  for i in %{perlver} %{perlmodcompat} ; do
    mkdir -pm 755 $RPM_BUILD_ROOT%{_libdir}/perl5/site_perl/$i/%{_arch}-%{_os}%{thread_arch}/auto
    mkdir -pm 755 $RPM_BUILD_ROOT%{_libdir}/perl5/vendor_perl/$i/%{_arch}-%{_os}%{thread_arch}/auto
  done

  # XXX
%ifarch %{multilib_64_archs}
  mkdir -pm 755 $RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{perlver}
  mkdir -pm 755 $RPM_BUILD_ROOT/usr/lib/perl5/vendor_perl/%{perlver}
%endif

  # XXX
  mkdir -p $RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}/Net
  install -m 0644 %{SOURCE12} $RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}/Net/libnet.cfg

  # XXX
  find $RPM_BUILD_ROOT -name '*HiRes*'  | xargs rm -rfv
  find $RPM_BUILD_ROOT -name '*Filter*' | xargs rm -rfv
  find $RPM_BUILD_ROOT -name '*NDBM*'   | xargs rm -rfv
  find $RPM_BUILD_ROOT -type f -name '*.bs' -a -empty -exec rm -f {} ';'

  # XXX
  find $RPM_BUILD_ROOT -type f -or -type l             > MANIFEST.all
  find $RPM_BUILD_ROOT -type d -printf "%%%%dir %p\n" >> MANIFEST.all

  %{new_perl} -i -p -e "s|$RPM_BUILD_ROOT||g;"           MANIFEST.all
  %{new_perl} -i -p -e 's((^/usr/share/man/.*))($1\*)g' MANIFEST.all
  cp MANIFEST.all /tmp

  for i in  %{SOURCE10}
  do
    %{new_perl} %{SOURCE1} %{_arch} $i MANIFEST.all MANIFEST.all.tmp %{_libdir} %{thread_arch}
    mv MANIFEST.all.tmp MANIFEST.all
  done

  %{new_perl} %{SOURCE1} %{_arch} %{SOURCE9} MANIFEST.all MANIFEST.all.tmp %{_libdir} %{thread_arch}
  mv MANIFEST.all.tmp MANIFEST.all

  # fix the rest of the stuff
  find $RPM_BUILD_ROOT%{_libdir}/perl* -name .packlist -o -name perllocal.pod -o -name config.h | \
    %{new_perl_flags} xargs $RPM_BUILD_ROOT/%{_bindir}/perl -I lib/ -i -p -e "s|$RPM_BUILD_ROOT||g;" MANIFEST.all

  %{new_perl} -i -p -e "s|$RPM_BUILD_ROOT||g;"           $RPM_BUILD_ROOT/%{_libdir}/perl5/%{version}/%{_arch}-%{_os}%{thread_arch}/Config_heavy.pl

  chmod -R u+w $RPM_BUILD_ROOT/*

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Sep 08 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.8.7, Release 6
  - Force locwarn to a non-true value in locale.c to shut up the
    "Setting locale failed" warnings.

* Wed Aug 31 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.8.7, Release 5
  - Fix the perl-suidperl Requires (add the epoch).

* Tue Jul 26 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.8.7, Release 4
  - Add a patch to correctly install on 64bit systems.
  - Other x86_64 improvements.

* Wed Jul 20 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.8.7, Release 3
  - Bring back the epoch.

* Wed Jul 06 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.8.7, Release 2
  - Update filter-depends (so we don't need an epoch) to ignore
    Filter::Util::Call, Tie::RangeHash, and specific 5.00* perl versions.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.8.7, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
